//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 White
#property indicator_color2 DeepSkyBlue
#property indicator_color3 DarkGoldenrod
#property indicator_color4 Yellow
#property indicator_color5 Red
#property indicator_color6 Lime

//---- indicator parameters
extern int    Period_1 = 15;
extern double Deviations = 1.5;

extern int    Period_2 = 15;

//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
double MovingBuffer_2[];
double UpperBuffer_2[];
double LowerBuffer_2[];
int    Period_ind;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (Period_1 > Period_2) Period_ind = Period_1;
   else Period_ind = Period_2;

//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,MovingBuffer_2);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,UpperBuffer_2);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,LowerBuffer_2);

//----
   SetIndexDrawBegin(0,Period_ind);
   SetIndexDrawBegin(1,Period_ind);
   SetIndexDrawBegin(2,Period_ind);
   SetIndexDrawBegin(3,Period_ind);
   SetIndexDrawBegin(4,Period_ind);
   SetIndexDrawBegin(5,Period_ind);

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i, k, counted_bars = IndicatorCounted();
   double deviation;
   double sum, MA;
   double max = -10000.0;
   double min =  10000.0;

//----
   if(Bars <= Period_ind) return(0);

//---- initial zero
   if(counted_bars < 1)
      for(i = 1; i <= Period_ind; i++)
      {
         MovingBuffer[Bars-i] = EMPTY_VALUE;
         UpperBuffer[Bars-i]  = EMPTY_VALUE;
         LowerBuffer[Bars-i]  = EMPTY_VALUE;
         UpperBuffer_2[Bars-i] = EMPTY_VALUE;
         LowerBuffer_2[Bars-i]  = EMPTY_VALUE;
      }

//----
   i = Bars - Period_ind - 1;
   if ( counted_bars > Period_ind - 1) i = Bars - counted_bars - 1;
   while( i >= 0)
   {
      k = i + Period_1 - 1;
      sum = 0.0; max = -10000.0; min =  10000.0;
      while(k >= i)
      {
         MA = (iClose( NULL, 0, k) + iHigh( NULL, 0, k) + iLow( NULL, 0, k) + iOpen( NULL, 0, k))/4;
         sum += MA;
         if (max < MA) max = MA;
         if (min > MA) min = MA;
         k--;
      }

      if (Deviations == 0) {Alert ("  0    n_bars == 0"); return(0);} else
      deviation = ((max - min)/Deviations);

      MovingBuffer[i] = sum/Period_1;
      UpperBuffer[i] = MovingBuffer[i] + deviation;
      LowerBuffer[i] = MovingBuffer[i] - deviation;
      
      k = i + Period_2 - 1;
      max = -10000.0; min =  10000.0;
      while(k >= i)
      {
         if (max < iHigh( NULL, 0, k)) max = iHigh( NULL, 0, k);
         if (min > iLow( NULL, 0, k))  min = iLow( NULL, 0, k);
         k--;
      }
      UpperBuffer_2[i] = max;
      LowerBuffer_2[i] = min;
      MovingBuffer_2[i] = (max + min)/2;
      
      i--;
   }

//----
   return(0);
}
//+------------------------------------------------------------------+